/////////////////////////////////////////////////////////////////////////////
//
//	file inexio_multi.h
//
//
//  Version 1.10
//
//  Copyright (C) 2005-  NEXIO Co., Ltd. All rights reserved
//
//	Homepage : http://www.inexio.co.kr
//
/////////////////////////////////////////////////////////////////////////////
#ifndef __INEXIO_MULTI_H_
#define __INEXIO_MULTI_H_

#define NXSDK_MAX_POINT		1024

// nxs_SPointInfo.bs
#define NXSDK_BS_INVALID	0
#define NXSDK_BS_MOVE		1
#define NXSDK_BS_UP			2
#define NXSDK_BS_DOWN		3

#define BULK_BASE_ID		NXSDK_MAX_POINT

typedef struct _nxs_SPointInfo
{
	WORD			bs;		// NXSDK_BS_INVALID
	WORD			id;
	WORD			idn;	// id new
	WORD			usbid;	// UsbPortID
	int				x;
	int				y;
	int				wx;
	int				wy;
	float			fx;		// 0~1.0
	float			fy;		// 0~1.0

	char			RES[40];
}
nxs_SPointInfo;

typedef struct _nxs_SInputPoints
{
	short			nPoints;		// count of total points
	short			nValids;		// count of valid points
	DWORD			dwTick;			// tick count
	DWORD			dwSeq;			// sequence number
	int				iTouchState;	// NXSDK_BS_DOWN
	nxs_SPointInfo	Points[NXSDK_MAX_POINT];
}
nxs_SInputPoints;

// Report Mode
#define RM_HIDNATIVE			0x01	// HID Native Touch
#define RM_GENERIC				0x02	// Use Data Channel

extern "C" __declspec(dllexport)
int __stdcall nxs_GetReportMode();

extern "C" __declspec(dllexport)
void __stdcall nxs_SetReportMode( int iReportMode );

// return true(data available), false(no-data)
extern "C" __declspec(dllexport)
int __stdcall nxs_GetInputPoints( nxs_SInputPoints *pPt );

extern "C" __declspec(dllexport)
void __stdcall nxs_GetInputPoints_Stop();

#endif// #ifndef __INEXIO_MULTI_H_
