// nxMultiSDK-Sample.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "nxMultiSDK-Sample.h"

#define MAX_LOADSTRING 100

HWND				g_hWnd;
HANDLE				g_hThread;
int					g_isStop;

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_NXMULTISDKSAMPLE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_NXMULTISDKSAMPLE));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_NXMULTISDKSAMPLE));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_NXMULTISDKSAMPLE);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   g_hWnd = hWnd;

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}




#ifdef _DEBUG
	#pragma comment(lib, "../Debug/nxMultiSDK.lib")
#else
	#pragma comment(lib, "../Release/nxMultiSDK.lib")
#endif
#include "inexio_multi_sdk.h"

DWORD WINAPI __procTouch( void *pVoid )
{
	nxs_SInputPoints	Inputs;
	RECT				rcPt;
	RECT				rcCli;
	int					bAllUp;
	int					i;
	HDC					hDC;
	DWORD				dwFmt = DT_SINGLELINE|DT_LEFT|DT_VCENTER;
	TCHAR				Str[80];

	nxs_SetReportMode( RM_GENERIC );
//	nxs_SetReportMode( RM_HIDNATIVE | RM_GENERIC );

	while( !g_isStop )
	{
		if( !nxs_GetInputPoints( &Inputs ) )
		{
			//Sleep( 1 );
			continue;
		}
		//if( !Inputs.nValids ) continue;

		bAllUp = true;

		GetClientRect( g_hWnd, &rcCli );

		hDC = GetDC( g_hWnd );

		if( DRAW_TYPE_LASTONLY )
			SelectObject( hDC, GetStockObject(NULL_BRUSH) );
		else
			SelectObject( hDC, GetStockObject(WHITE_BRUSH) );

		SelectObject( hDC, GetStockObject(WHITE_PEN) );
		SetTextColor( hDC, RGB(255,255,255) );
		SetBkMode( hDC, TRANSPARENT );

		if( DRAW_TYPE_LASTONLY )
			::FillRect( hDC, &rcCli
				, (HBRUSH)GetStockObject(BLACK_BRUSH) );

		for( i=0; i<Inputs.nPoints; ++i )
		{
			if( Inputs.Points[i].bs==NXSDK_BS_INVALID ) continue;
			if( Inputs.Points[i].bs!=NXSDK_BS_UP ) bAllUp = false;

			rcPt.left	= Inputs.Points[i].x - Inputs.Points[i].wx/2;
			rcPt.right	= Inputs.Points[i].x + Inputs.Points[i].wx/2;
			rcPt.top	= Inputs.Points[i].y - Inputs.Points[i].wy/2;
			rcPt.bottom	= Inputs.Points[i].y + Inputs.Points[i].wy/2;

			ScreenToClient( g_hWnd, (POINT*)&rcPt.left );
			ScreenToClient( g_hWnd, (POINT*)&rcPt.right );

			Ellipse( hDC, rcPt.left, rcPt.top, rcPt.right, rcPt.bottom );

			rcPt.left = rcPt.right+3;
			rcPt.right = rcPt.left+50;
			rcPt.top -= 20;
			rcPt.bottom += 20;

			if( DRAW_TYPE_LASTONLY )
			{
				_stprintf_s( Str, _T("%d"), Inputs.Points[i].id );
				DrawText( hDC, Str, -1, &rcPt, dwFmt );
			}
		}
		ReleaseDC( g_hWnd, hDC );

		if( bAllUp ) InvalidateRect( g_hWnd, 0, true );
	}

	nxs_SetReportMode( RM_HIDNATIVE );

	return 0;
}


//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_CREATE:
		{
		g_hThread = CreateThread( 0, 0, __procTouch, 0, 0, 0 );
		ShowWindow( hWnd, SW_MAXIMIZE );
		}
		return 0;

	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		g_isStop = 1;

		nxs_GetInputPoints_Stop();

		WaitForSingleObject( g_hThread, INFINITE );
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
